<h1 align="center">HoloCheckerBot</h1>

<p align="center">Small Telegram bot made on Pyrogram</p>

<p align="center">
<a href="https://git.end-play.xyz/HoloUA/Telegram/src/branch/master/LICENSE"><img alt="License: GPL" src="https://img.shields.io/badge/License-GPL-blue"></a>
<a href="https://git.end-play.xyz/HoloUA/Telegram"><img alt="Code style: black" src="https://img.shields.io/badge/code%20style-black-000000.svg"></a>
</p>  

## What can this bot do?

* Get user applications
* Send applications to the admins
* Give one-time links to join group
* Track down users that were not allowed to join
* Show applications to other users
* Manage YouTube sponsorships [WIP]
* Send and receive messages to users using bot [WIP]

## Installation

1. `git clone https://git.end-play.xyz/HoloUA/Telegram.git`
2. `cd Telegram`
3. Install Python 3.7+ (at least 3.9 is recommended) for your OS
4. `python3 -m pip install -r requirements.txt`
5. Run it with `python3 holochecker.py` after configuring

## Configuration

So bot has its "config_example.json" and it needs to be changed.
Copy this file to "config.json" and open it with any text editor.  

You should also install [HoloCheckerAPI](https://git.end-play.xyz/HoloUA/API) for inline requests to work.  

After all of that you're good to go! Happy using :)

## To-Do

* [ ] Stats and infographics
* [ ] Check group members without completed application
* [x] Replicate some functions of @spoilerobot
* [x] Check sponsorship on Holo girls
* [x] /nearby command
* [x] Complete messenger between user and admins
* [x] Get application by id and user_id  
