from app import app
from pyrogram import filters
from pyrogram.types import InlineKeyboardMarkup, InlineKeyboardButton, Message
from pyrogram.client import Client
from modules.utils import configGet, locale
from modules import custom_filters


@app.on_message(
    custom_filters.enabled_general
    & ~filters.scheduled
    & filters.private
    & filters.command(["issue"], prefixes=["/"])
    & ~custom_filters.banned
)
async def cmd_issue(app: Client, msg: Message):
    await msg.reply_text(
        locale("issue", "message", locale=msg.from_user),
        disable_web_page_preview=True,
        reply_markup=InlineKeyboardMarkup(
            [
                [
                    InlineKeyboardButton(
                        locale("issue", "button", locale=msg.from_user),
                        url=configGet("issues"),
                    )
                ]
            ]
        ),
    )
